# uni-active

## 介绍

uni-active 是通过主动学习的方式，实现对样本输入参数优化，实现预测性能提升的软件工具。
应用于科学、工业领域的成分配比、工艺条件等进行机器学习辅助优化。

uni-active 核心为网格生成（grid），采样算法(selection)模块。同时，建立数据集(dataset)模块，打包了用户的繁琐的数据交互过程，
使得用户无需在代码中显示地控制循环流程，更加关注于建模与分析。

## 背景
在监督学习中，存在标记成本昂贵问题。在此问题下，如何选取更少的哪些样本，实现模型最大的性能提升是非常重要的问题。
主动学习（Active Learning）尝试通过选择性的标记较少的数据，而训练出表现较好的模型。

下图是一个简单的例子，图（c）使用主动学习策略，仅选取30个样本，作为训练集训练出的逻辑回归模型即可达到90%的准确率，
而图（b）随机挑选的30个样本训练出的模型却表现较差。因此，主动学习的确能够缩减支出成本。

![人工构造的数据集中（a），主动学习(b)与随机选择（c）对比](active.png)

主动学习通常使用``模型预测``->``实验值反馈``->``模型优化``的方式，不断循环上述步骤，实现对关键样本点的标记与补充，
实现对模型的性能的不断提高。

![Active learning模型提高曲线](opt.png)

上述应用目标在于提高模型效果，而另一种应用方式是，通过在主动学习采样函数中加入对于目标的偏好，
使得采样更加具有“价值”的样本, 如选择目标值更大的样本并迭代，使得模型不断预测出更优的输入样本，便能实现对于输入的不断优化。

Reference: 
    DOI: 10.1016/j.actamat.2019.03.010

## 安装 

方式1. 

    pip install uni_active

方式2.

    cd .
    python setup.py install

## Guide

[sample1](samples/sample1/sample1.ipynb)





